type lexme =
  | Nombre of int
  | Op1 of (int -> int)
  | Op2 of (int * (int -> int -> int))
  | Parg
  | Pard
;;

let dcompose s =
  let l = ref [] in
  for i=0 to string_length(s)-1 do match s.[i] with
    | ` ` -> ()
    | `~` -> l := Op1(minus_int)  :: !l
    | `+` -> l := Op2(1,add_int)  :: !l
    | `-` -> l := Op2(1,sub_int)  :: !l
    | `*` -> l := Op2(2,mult_int) :: !l
    | `/` -> l := Op2(2,div_int)  :: !l
    | `(` -> l := Parg  :: !l
    | `)` -> l := Pard  :: !l
    | `0`..`9` as c -> begin
	let x = char__int_of_char(c) - char__int_of_char(`0`) in
	match !l with
	  | Nombre(y)::suite when (i > 0) & (s.[i-1] <> ` `)
	      -> l := Nombre(x+10*y)::suite
	  | _ -> l := Nombre(x) :: !l
      end
    | _ -> failwith "caractre imprvu"
  done;
  rev !l
;;

dcompose "31 * (~4 + 5)";;

let rec eval_post pile f =
  if f = [] then match pile with
      | [a] -> a
      | _   -> failwith "erreur de syntaxe"
  else match hd(f),pile with
      | Nombre(n),_            -> eval_post (n::pile)        (tl f)
      | Op1(g),  (a::suite)    -> eval_post ((g a)::suite)   (tl f)
      | Op2(_,g),(a::b::suite) -> eval_post ((g b a)::suite) (tl f)
      | _ -> failwith "erreur de syntaxe"
;;
  
eval_post [] (dcompose "31 4 ~ 5 - *");;

let rec empile x pile = match x,pile with

  (* opration unaire en attente *)
  | Nombre(n), Op1(g)::suite ->
      empile (Nombre(g n)) suite

  (* opration binaire prioritaire *)
  | Op2(p,g),  Nombre(b)::Op2(q,h)::Nombre(a)::suite when p <= q ->
      empile x (Nombre(h a b)::suite)

  (* parenthse fermante *)
  | Pard,  Nombre(b)::Op2(q,h)::Nombre(a)::suite ->
      empile x (Nombre(h a b)::suite)
  | Pard, Nombre(n)::Parg::suite ->
      empile (Nombre n) suite

  (* autres cas *)
  | _,_ -> x::pile
;;

let rec eval_inf pile f = match f with
  | [] -> pile
  | x::suite -> eval_inf (empile x pile) suite
;;

let eval ch = let l = dcompose ch in
              let p = eval_inf [] (Parg :: l @ [Pard]) in
	      match p with
		| [Nombre(x)] -> x
		| _ -> failwith "formule incorrecte"
;;

eval "31 + 4*5 ";;
